// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'VrScanner.pas' rev: 6.00

#ifndef VrScannerHPP
#define VrScannerHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Menus.hpp>	// Pascal unit
#include <VrThreads.hpp>	// Pascal unit
#include <VrSysUtils.hpp>	// Pascal unit
#include <VrControls.hpp>	// Pascal unit
#include <VrClasses.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Vrscanner
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TVrLedStyle;
class PASCALIMPLEMENTATION TVrLedStyle : public Vrclasses::TVrPersistent 
{
	typedef Vrclasses::TVrPersistent inherited;
	
private:
	Graphics::TColor FInnerHigh;
	Graphics::TColor FInnerShadow;
	int FInnerWidth;
	Graphics::TColor FOuterHigh;
	Graphics::TColor FOuterShadow;
	int FOuterWidth;
	Graphics::TColor FPaletteHigh1;
	Graphics::TColor FPaletteHigh2;
	Graphics::TColor FPaletteLow1;
	Graphics::TColor FPaletteLow2;
	void __fastcall SetInnerHigh(Graphics::TColor Value);
	void __fastcall SetInnerShadow(Graphics::TColor Value);
	void __fastcall SetInnerWidth(int Value);
	void __fastcall SetOuterHigh(Graphics::TColor Value);
	void __fastcall SetOuterShadow(Graphics::TColor Value);
	void __fastcall SetOuterWidth(int Value);
	void __fastcall SetPaletteHigh1(Graphics::TColor Value);
	void __fastcall SetPaletteHigh2(Graphics::TColor Value);
	void __fastcall SetPaletteLow1(Graphics::TColor Value);
	void __fastcall SetPaletteLow2(Graphics::TColor Value);
	
public:
	__fastcall TVrLedStyle(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property Graphics::TColor InnerHigh = {read=FInnerHigh, write=SetInnerHigh, nodefault};
	__property Graphics::TColor InnerShadow = {read=FInnerShadow, write=SetInnerShadow, default=0};
	__property int InnerWidth = {read=FInnerWidth, write=SetInnerWidth, default=1};
	__property Graphics::TColor OuterHigh = {read=FOuterHigh, write=SetOuterHigh, default=0};
	__property Graphics::TColor OuterShadow = {read=FOuterShadow, write=SetOuterShadow, default=0};
	__property int OuterWidth = {read=FOuterWidth, write=SetOuterWidth, default=1};
	__property Graphics::TColor PaletteHigh1 = {read=FPaletteHigh1, write=SetPaletteHigh1, nodefault};
	__property Graphics::TColor PaletteHigh2 = {read=FPaletteHigh2, write=SetPaletteHigh2, default=0};
	__property Graphics::TColor PaletteLow1 = {read=FPaletteLow1, write=SetPaletteLow1, nodefault};
	__property Graphics::TColor PaletteLow2 = {read=FPaletteLow2, write=SetPaletteLow2, default=0};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TVrLedStyle(void) { }
	#pragma option pop
	
};


#pragma option push -b-
enum TVrScanDirection { sdBoth, sdLeftRight, sdRightLeft };
#pragma option pop

class DELPHICLASS TVrScanner;
class PASCALIMPLEMENTATION TVrScanner : public Vrcontrols::TVrGraphicImageControl 
{
	typedef Vrcontrols::TVrGraphicImageControl inherited;
	
private:
	Vrcontrols::TVrIntMax FLeds;
	Graphics::TBitmap* FLedImage;
	int FLedHeight;
	int FLedWidth;
	int FOffset;
	int FSpacing;
	TVrLedStyle* FLedStyle;
	int FPosition;
	TVrScanDirection FDirection;
	Vrcontrols::TVrInt10 FColorWidth;
	bool FActive;
	Vrthreads::TVrTimer* FTimer;
	Classes::TNotifyEvent FOnChange;
	bool ToLeft;
	int __fastcall GetTimeInterval(void);
	bool __fastcall GetThreaded(void);
	void __fastcall SetActive(bool Value);
	void __fastcall SetLeds(Vrcontrols::TVrIntMax Value);
	void __fastcall SetSpacing(int Value);
	void __fastcall SetColorWidth(Vrcontrols::TVrInt10 Value);
	void __fastcall SetPosition(int Value);
	void __fastcall SetLedStyle(TVrLedStyle* Value);
	void __fastcall LedStyleChanged(System::TObject* Sender);
	void __fastcall SetTimeInterval(int Value);
	void __fastcall SetThreaded(bool Value);
	void __fastcall TimerEvent(System::TObject* Sender);
	
protected:
	virtual void __fastcall Loaded(void);
	virtual void __fastcall Paint(void);
	void __fastcall PaintLed(Graphics::TCanvas* ACanvas, int Index, bool Active);
	virtual void __fastcall UpdateLedImage(void);
	HIDESBASE virtual void __fastcall Changed(void);
	
public:
	__fastcall virtual TVrScanner(Classes::TComponent* AOwner);
	__fastcall virtual ~TVrScanner(void);
	virtual void __fastcall SetBounds(int ALeft, int ATop, int AWidth, int AHeight);
	
__published:
	__property Vrcontrols::TVrIntMax Leds = {read=FLeds, write=SetLeds, default=7};
	__property TVrLedStyle* LedStyle = {read=FLedStyle, write=SetLedStyle};
	__property int Spacing = {read=FSpacing, write=SetSpacing, default=2};
	__property Vrcontrols::TVrInt10 ColorWidth = {read=FColorWidth, write=SetColorWidth, default=1};
	__property TVrScanDirection Direction = {read=FDirection, write=FDirection, default=0};
	__property int Position = {read=FPosition, write=SetPosition, default=-1};
	__property bool Threaded = {read=GetThreaded, write=SetThreaded, nodefault};
	__property bool Active = {read=FActive, write=SetActive, default=0};
	__property int TimeInterval = {read=GetTimeInterval, write=SetTimeInterval, default=100};
	__property Transparent  = {default=0};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property Align  = {default=0};
	__property Anchors  = {default=3};
	__property Constraints ;
	__property Color  = {default=-2147483643};
	__property DragCursor  = {default=-12};
	__property DragKind  = {default=0};
	__property DragMode  = {default=0};
	__property Hint ;
	__property ParentColor  = {default=1};
	__property ParentShowHint  = {default=1};
	__property PopupMenu ;
	__property ShowHint ;
	__property Visible  = {default=1};
	__property OnClick ;
	__property OnContextPopup ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDock ;
	__property OnEndDrag ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property OnStartDock ;
	__property OnStartDrag ;
};


class DELPHICLASS TVrIndicator;
class PASCALIMPLEMENTATION TVrIndicator : public Vrcontrols::TVrGraphicImageControl 
{
	typedef Vrcontrols::TVrGraphicImageControl inherited;
	
private:
	Vrcontrols::TVrIntMax FLeds;
	Graphics::TBitmap* FLedImage;
	int FLedHeight;
	int FLedWidth;
	int FOffset;
	int FSpacing;
	TVrLedStyle* FLedStyle1;
	TVrLedStyle* FLedStyle2;
	TVrLedStyle* FLedStyle3;
	int FPosition;
	int FMinValue;
	int FMaxValue;
	Vrcontrols::TVrPercentInt FPercent1;
	Vrcontrols::TVrPercentInt FPercent2;
	Vrcontrols::TVrInt10 FColorWidth;
	int FStep;
	Classes::TNotifyEvent FOnChange;
	int __fastcall GetPercentDone(void);
	void __fastcall SetLeds(Vrcontrols::TVrIntMax Value);
	void __fastcall SetSpacing(int Value);
	void __fastcall SetColorWidth(Vrcontrols::TVrInt10 Value);
	void __fastcall SetPosition(int Value);
	void __fastcall SetMinValue(int Value);
	void __fastcall SetMaxValue(int Value);
	void __fastcall SetPercent1(Vrcontrols::TVrPercentInt Value);
	void __fastcall SetPercent2(Vrcontrols::TVrPercentInt Value);
	void __fastcall SetLedStyle1(TVrLedStyle* Value);
	void __fastcall SetLedStyle2(TVrLedStyle* Value);
	void __fastcall SetLedStyle3(TVrLedStyle* Value);
	void __fastcall LedStyleChanged(System::TObject* Sender);
	
protected:
	virtual void __fastcall Loaded(void);
	virtual void __fastcall Paint(void);
	void __fastcall PaintLed(Graphics::TCanvas* ACanvas, int Index, int ColorIndex, bool Active);
	virtual void __fastcall UpdateLedImage(void);
	HIDESBASE virtual void __fastcall Changed(void);
	
public:
	__fastcall virtual TVrIndicator(Classes::TComponent* AOwner);
	__fastcall virtual ~TVrIndicator(void);
	virtual void __fastcall SetBounds(int ALeft, int ATop, int AWidth, int AHeight);
	void __fastcall StepIt(void);
	void __fastcall StepBy(int Delta);
	__property int PercentDone = {read=GetPercentDone, nodefault};
	
__published:
	__property int MinValue = {read=FMinValue, write=SetMinValue, default=0};
	__property int MaxValue = {read=FMaxValue, write=SetMaxValue, default=100};
	__property Vrcontrols::TVrIntMax Leds = {read=FLeds, write=SetLeds, default=7};
	__property TVrLedStyle* LedStyle1 = {read=FLedStyle1, write=SetLedStyle1};
	__property TVrLedStyle* LedStyle2 = {read=FLedStyle2, write=SetLedStyle2};
	__property TVrLedStyle* LedStyle3 = {read=FLedStyle3, write=SetLedStyle3};
	__property int Spacing = {read=FSpacing, write=SetSpacing, default=2};
	__property Vrcontrols::TVrInt10 ColorWidth = {read=FColorWidth, write=SetColorWidth, default=1};
	__property int Position = {read=FPosition, write=SetPosition, default=0};
	__property Vrcontrols::TVrPercentInt Percent1 = {read=FPercent1, write=SetPercent1, default=50};
	__property Vrcontrols::TVrPercentInt Percent2 = {read=FPercent2, write=SetPercent2, default=30};
	__property int Step = {read=FStep, write=FStep, default=10};
	__property Transparent  = {default=0};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property Align  = {default=0};
	__property Anchors  = {default=3};
	__property Constraints ;
	__property Color  = {default=-2147483643};
	__property DragCursor  = {default=-12};
	__property DragKind  = {default=0};
	__property DragMode  = {default=0};
	__property Hint ;
	__property ParentColor  = {default=1};
	__property ParentShowHint  = {default=1};
	__property PopupMenu ;
	__property ShowHint ;
	__property Visible  = {default=1};
	__property OnClick ;
	__property OnContextPopup ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDock ;
	__property OnEndDrag ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property OnStartDock ;
	__property OnStartDrag ;
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Vrscanner */
using namespace Vrscanner;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// VrScanner
